import * as Schema from '../src/gloria-notification-schema'
import * as Ajv from 'ajv'

const ajv = new Ajv()

const Cases = {
  Empty: {}
, Lite: {
    message: 'message'
  }
, Full: {
    title: 'title'
  , message: 'message'
  , iconUrl: 'iconUrl'
  , imageUrl: 'imageUrl'
  , url: 'url'
  , id: 'id'
  , via: 'via'
  }
, Extra: {
    title: 'title'
  , message: 'message'
  , iconUrl: 'iconUrl'
  , imageUrl: 'imageUrl'
  , url: 'url'
  , id: 'id'
  , via: 'via'
  , extra: 'extra'
  }
, Mixed: {
    message: 'message'
  , extra: 'extra'
  }
, Wrong: {
    message: 666
  }
}

test('Validate: GloriaNotificationSchema', () => {
  const validate = ajv.compile(Schema.GloriaNotificationSchema)
  expect(validate(Cases.Empty)).toBeTruthy()
  expect(validate(Cases.Lite)).toBeTruthy()
  expect(validate(Cases.Full)).toBeTruthy()
  expect(validate(Cases.Extra)).toBeTruthy()
  expect(validate(Cases.Mixed)).toBeTruthy()
  expect(validate(Cases.Wrong)).toBeFalsy()
})

test('Validate: GloriaNotificationListSchema', () => {
  const validate = ajv.compile(Schema.GloriaNotificationListSchema)
  expect(validate([Cases.Empty])).toBeTruthy()
  expect(validate([Cases.Lite])).toBeTruthy()
  expect(validate([Cases.Full])).toBeTruthy()
  expect(validate([Cases.Extra])).toBeTruthy()
  expect(validate([Cases.Mixed])).toBeTruthy()
  expect(validate([Cases.Wrong])).toBeFalsy()
})
